#!/bin/bash
# use "level:catset" as arg1 "baseport" - base TCP port as arg2


case "$1" in
  *:*)
    lev="${1%%:*}"
    ;;
  *.*)
    lev="${1%%.*}"
    ;;
  *)
    lev="$1"
    ;;
esac


echo "Setting for level $lev full_level $1 base_port $2"
cp bacula-fd.service /etc/systemd/system/bacula-fd-$1.service
cp bacula-sd.service /etc/systemd/system/bacula-sd-$1.service
cp bacula-dir.service /etc/systemd/system/bacula-dir-$1.service

sed -i s/LEV/$1/ /etc/systemd/system/bacula-fd-$1.service
sed -i s/LEV/$1/ /etc/systemd/system/bacula-dir-$1.service
sed -i s/LEV/$1/ /etc/systemd/system/bacula-sd-$1.service


sed -i s/LAV/$lev/ /etc/systemd/system/bacula-fd-$1.service
sed -i s/LAV/$lev/ /etc/systemd/system/bacula-dir-$1.service
sed -i s/LAV/$lev/ /etc/systemd/system/bacula-sd-$1.service

# to be able to backup and restore without DAC restrictions
setcap cap_chown,cap_dac_override,cap_fowner,cap_fsetid=+ep /usr/sbin/bacula-fd

### Config files

mkdir -p /etc/bacula/$1
cp -ar etctemplate/* /etc/bacula/$1/
chgrp -R bacula /etc/bacula/$1
pushd /etc/bacula/$1
let PN1=$2
let PN2=$2+1
let PN3=$2+2

# change port numbers for each instance
# port numbers shall not overlap


find . -type f| xargs sed -i s/PN1/$PN1/ 
find . -type f| xargs sed -i s/PN2/$PN2/
find . -type f| xargs sed -i s/PN3/$PN3/

# change dirs
find . -type f | xargs sed -i s/LEV/$1/

popd

### backup db for using SQLITE
  

mkdir -p /var/lib/bacula/mls/$1
cp -arv vartemplate/* /var/lib/bacula/mls/$1
chown -R backupper_$lev.bacula /var/lib/bacula/mls/$1
chcon -u generic_u -t def_t  -R -l $1 /var/lib/bacula/mls/$1/
mkdir -p /srv/backup/$1
chown -R backupper_$lev.bacula /srv/backup/$1
chcon -u generic_u -t def_t  -R -l $1 /srv/backup/$1/
